EASYSOFT ODBC-JDBC GATEWAY (Release 2.4.0)

Any problems you encounter should be reported via easysoft support

  support@easysoft.com

or by contacting Easysoft Ltd on +44 (0) 1937 860 450.

This file can be found at

  ftp://ftp.easysoft.com/pub/odbc-jdbc-gateway/README.txt

OVERVIEW

The Easysoft ODBC-JDBC Gateway is an ODBC driver that can be
used to provide ODBC access to JDBC data sources.

The Easysoft ODBC-JDBC Gateway is written in C and Java. It
uses the JNI (Java Native Interface) to load JDBC Driver
classes and to call JDBC methods in the loaded JDBC
drivers.

The driver dll/so (o2jg.dll/o2jg.so) contains an implementation of all
the ODBC API functions. A separate dll/so (o2jgS.dll/o2jgS.so)
contains the ODBC Setup API functions.

INSTALLATION

Please read INSTALL.txt in the main distribution.

SYSTEM REQUIREMENTS

As the driver uses Java and JNI to access the JDBC driver, the basic 
system requirements are the same as for JDK/JRE 1.3, 1.4, 1.5, 1.6 or 1.7. The JDBC 
Driver classes for intended JDBC data source must be available on
the machine running the gateway.

CONFIGURING DATA SOURCES

Before you attempt to create an ODBC data source to connect
to your chosen JDBC data source, ensure that:

1. the JDBC data source is working
2. you have all the driver classes contained in a single jar file
3. you have all the information required to set up a JDBC connection with the
   chosen JDBC Driver e.g. the JDBC driver's class name, the
   location and name of the jar file containing the JDBC driver to be used
   and an appropriate JDBC URL

The Easysoft ODBC-JDBC Gateway has been tested with the following applications:
      
   	  Microsoft Access
	  Actuate
	  Microsoft Bench32
	  Borland Delphi
	  Microsoft Excel
	  Microsoft Query
	  WinSQL

and with the JDBC Drivers for the following databases:

	  Cloudscape
	  FirstSQL
	  HSQL
	  JDataStore
	  Mckoi
	  OpenBase
	  PointBase  
	  Sybase SQL Anywhere
	  MS SQL Server
	  Oracle Thin Client

CURRENT STATUS

The following ODBC API calls are implemented:

 SQLAllocHandle 
 SQLAllocEnv
 SQLBindCol
 SQLBindParameter
 SQLCancel
 SQLCloseCursor
 SQLColAttribute
 SQLColAttributes
 SQLColumns
 SQLColumnPrivileges
 SQLConnect
 SQLDescribeCol
 SQLDisconnect
 SQLDriverConnect
 SQLEndTran
 SQLExecDirect
 SQLExecute
 SQLExtendedFetch
 SQLFetch 
 SQLFetchScroll
 SQLForeignKeys 
 SQLFreeHandle
 SQLFreeStmt
 SQLGetConnectAttr
 SQLGetCursorName
 SQLGetData
 SQLGetDescField
 SQLGetDescRec
 SQLGetDiagField
 SQLGetDiagRec
 SQLGetEnvAttr
 SQLGetFunctions
 SQLGetInfo
 SQLGetStmtAttr
 SQLGetTypeInfo
 SQLMoreResults 
 SQLNativeSql
 SQLNumResultCols
 SQLParamData 
 SQLPrepare
 SQLPrimaryKeys
 SQLProcedures
 SQLProcedureColumns
 SQLPutData 
 SQLRowCount
 SQLSetConnectAttr
 SQLSetCursorName
 SQLSetDescField
 SQLSetDescRec
 SQLSetEnvAttr
 SQLSetStmtAttr
 SQLSpecialColumns
 SQLStatistics
 SQLTables 
 SQLTablePrivileges 
 SQLColAttributeW
 SQLColAttributesW
 SQLColumnPrivilegesW
 SQLColumnsW
 SQLConnectW
 SQLDescribeColW
 SQLDriverConnectW
 SQLExecDirectW
 SQLForeignKeysW
 SQLGetConnectAttrW
 SQLGetCursorNameW
 SQLGetDescFieldW
 SQLGetDescRecW
 SQLGetDiagFieldW
 SQLGetDiagRecW
 SQLGetInfoW
 SQLGetStmtAttrW
 SQLGetTypeInfoW
 SQLNativeSqlW
 SQLPrepareW
 SQLPrimaryKeysW
 SQLProcedureColumnsW
 SQLProceduresW
 SQLSetConnectAttrW
 SQLSetCursorNameW
 SQLSetStmtAttrW
 SQLSetDescFieldW
 SQLSpecialColumnsW
 SQLStatisticsW
 SQLTablePrivilegesW
 SQLTablesW

The following ODBC API calls are NOT currently implemented:

 SQLBrowseConnect
 SQLBulkOperations
 SQLCopyDesc
 SQLSetPos 
 SQLDescribeParam 
 SQLNumParams
 SQLSetScrollOptions (Deprecated in ODBC 3)

The parameter based calls are not supported because support for them is not 
provided in JDBC 2, when JDBC 3 drivers become more common targets for the Gateway, 
support for this will be added to later releases.

XA and distributed transactions
===============================

The gateway provides an entry point ojg_xaosw that is the X/Open xa_switch_t structure
that provides the XA switch table. Applications requiring XA support should be 
built to use this structure. The gateway will translate calls into the entry points
into the corresponding Java javax.sql.XADataSource methods.

struct xa_switch_t ojg_xaosw

For this to work the JDBC driver in use must provide the XA support, and the 
DSN entry must provide the XADataSource class name, and the method the driver offers to
create an Xid. The TA uses a connect string of the form (example from WebSphere MQ ini file)

XAOpenString=ODBCJDBC_XA+DSN=XA-OJG+LogFile=/tmp/sql.log+DB=dbname

The name of the DSN that contains the connection information is given in the DSN= value, and if 
logging is required specify that in the LogFile entry. The DB name is used to allow the ODBC 
connection to find the matching XA connection.

The matching DSN entry for the above string (using the Oracle JDBC driver) could be

[XA-OJG]
Driver      	= Easysoft ODBC-JDBC Gateway
Description     =
DriverClass     = oracle.jdbc.OracleDriver
User        	= system
Password        = master
ClassPath       = /usr/local/instantclient10_1/ojdbc14.jar
URL     	= jdbc:oracle:oci8:@//192.168.0.69:1521/tentwo.oracle
Strip_Quote     = 0
With_Schema     = 0
Single_Statement = 0
XA_Enlist       = 1
XA_Connection_String    = dbname
XAClass         = oracle.jdbc.xa.client.OracleXADataSource
XIDClass        = oracle.jdbc.xa.OracleXid

The above DSN, because it is designed to take part in a distributed transaction, may 
not be used from a normal connection.
